<template>
  <div class="chat-list">
    <!-- Start of Navigation -->
    <!-- Start of Sidebar -->
    <div class="sidebar" id="sidebar">
      <div class="container">
        <div class="col-md-12">
          <div class="row">
            <div class="col-md-10">
              <div class="search">
                <form class="form-inline position-relative">
                  <input
                    type="search"
                    class="form-control capsule"
                    id="conversations"
                    placeholder="Search for conversations..."
                    v-model="searchRoomList"
                    style="width:100%"
                  >
                  <button type="button" class="btn btn-link loop">
                    <i class="material-icons">search</i>
                  </button>
                </form>
              </div>
            </div>

            <div class="col-md-2 d-flex align-items-center">
              <img :src="asset('images/ui_elements/ic_setting_dgrey.png')" style="width:1.5vw">
            </div>
          </div>
          <div class="list-group sort mt-2">
            <!-- <div class="nav nav-tabs" id="nav-tab" role="tablist"> -->
            <a
              class="btn filterDiscussionsBtn nav-item nav-link active"
              id="nav-home-tab"
              data-toggle="tab"
              href="#all-tab"
              role="tab"
            >All</a>
            <a
              class="btn filterDiscussionsBtn nav-item nav-link"
              id="nav-home-tab"
              data-toggle="tab"
              href="#live-tab"
              role="tab"
            >Live</a>
            <a
              class="btn filterDiscussionsBtn nav-item nav-link"
              id="nav-home-tab"
              data-toggle="tab"
              href="#request-tab"
              role="tab"
            >Request</a>
            <!-- </div> -->
            <!-- <button class="btn filterDiscussionsBtn active show mr-2">All</button>
            <button class="btn filterDiscussionsBtn show mr-2">Live</button>
            <button class="btn filterDiscussionsBtn show mr-2">Request</button>-->
          </div>
        </div>

        <div class="col-md-12 px-0">
          <!-- Start of Discussions -->
          <div class="tab-content px-0" id="nav-tabContent">
            <div id="all-tab" class="tab-pane fade in active show" role="tabpanel">
              <div class="discussions">
                <div class="list-group pt-1">
                  <template v-show="loading">
                    <vcl-bullet-list v-show="loading"></vcl-bullet-list>
                  </template>
                  <template v-for="room in sortedRoomList">
                    <span
                      @click.prevent="selectChat(room)"
                      class="filterDiscussions all unread single py-2 pl-3"
                      :class="{'bg-active':isSelected(room.id)}"
                      style="cursor:pointer1"
                      :key="room.id"
                    >
                      <img
                        class="avatar-md"
                        :src="room.created_by.picture || asset('images/pictures/no_avatar.jpg')"
                        data-placement="top"
                        alt="avatar"
                        @error="imgErrorHandler"
                      >
                      <!-- <div class="status" v-show="room.unread_count">
                      <i class="material-icons online text-danger">fiber_manual_record</i>
                      </div>-->
                      <div class="new bg-danger" v-show="room.unread_count">
                        <span>{{room.unread_count}}</span>
                      </div>
                      <div class="data p-1">
                        <strong>
                          <span class="d-block float-left">{{room.created_by.name}}</span>
                        </strong>
                        <br>
                        <span
                          style="font-size:0.9em"
                          class="d-block float-left text-muted"
                        >{{getLastMessage(room.messages)}}</span>
                        <small
                          class="float-right text-muted align-self-center"
                        >{{parseDate(room.updated_at)}}</small>
                      </div>
                      <!-- <img
                      :src="asset(`images/ui_elements/ic_user_online.png`)"
                      alt="channel_image"
                      class="w-10 mr-1 align-self-center"
                      >-->
                      <img
                        :src="asset(`images/channels/${room.created_by.channel.name}.png`)"
                        alt="channel_image"
                        class="w-10 align-self-center channel-image"
                      >
                    </span>
                  </template>
                </div>
              </div>
            </div>

            <!-- live -->
            <div id="live-tab" class="tab-pane fade" role="tabpanel">
              <div class="discussions">
                <div class="list-group pt-1">
                  <template v-for="room in liveRoomList">
                    <span
                      @click.prevent="selectChat(room)"
                      class="filterDiscussions all unread single py-2 pl-3"
                      :class="{'bg-active':isSelected(room.id)}"
                      style="cursor:pointer1"
                      :key="room.id"
                    >
                      <img
                        class="avatar-md"
                        :src="room.created_by.picture || asset('images/pictures/no_avatar.jpg')"
                        data-placement="top"
                        alt="avatar"
                        @error="imgErrorHandler"
                      >
                      <!-- <div class="status" v-show="room.unread_count">
                      <i class="material-icons online text-danger">fiber_manual_record</i>
                      </div>-->
                      <div class="new bg-danger" v-show="room.unread_count">
                        <span>{{room.unread_count}}</span>
                      </div>
                      <div class="data p-1">
                        <strong>
                          <span class="d-block float-left">{{room.created_by.name}}</span>
                        </strong>
                        <br>
                        <span
                          class="d-block float-left text-muted"
                        >{{getLastMessage(room.messages)}}</span>
                        <small
                          class="float-right text-muted align-self-center"
                        >{{parseDate(room.updated_at)}}</small>
                      </div>
                      <!-- <img
                      :src="asset(`images/ui_elements/ic_user_online.png`)"
                      alt="channel_image"
                      class="w-10 mr-1 align-self-center"
                      >-->
                      <img
                        :src="asset(`images/channels/${room.created_by.channel.name}.png`)"
                        alt="channel_image"
                        class="w-10 align-self-center channel-image"
                      >
                    </span>
                  </template>
                </div>
              </div>
            </div>
            <div id="request-tab" class="tab-pane fade" role="tabpanel">
              <div class="discussions">
                <div class="list-group pt-1">
                  <template v-for="room in requestRoomList">
                    <span
                      @click.prevent="selectChat(room)"
                      class="filterDiscussions all unread single py-2 pl-3"
                      :class="{'bg-active':isSelected(room.id)}"
                      style="cursor:pointer1"
                      :key="room.id"
                    >
                      <img
                        class="avatar-md"
                        :src="room.created_by.picture || asset('images/pictures/no_avatar.jpg')"
                        data-placement="top"
                        alt="avatar"
                        @error="imgErrorHandler"
                      >
                      <!-- <div class="status" v-show="room.unread_count">
                      <i class="material-icons online text-danger">fiber_manual_record</i>
                      </div>-->
                      <div class="new bg-danger" v-show="room.unread_count">
                        <span>{{room.unread_count}}</span>
                      </div>
                      <div class="data p-1">
                        <strong>
                          <span class="d-block float-left">{{room.created_by.name}}</span>
                        </strong>
                        <br>
                        <span
                          class="d-block float-left text-muted"
                        >{{getLastMessage(room.messages)}}</span>
                        <small
                          class="float-right text-muted align-self-center"
                        >{{parseDate(room.updated_at)}}</small>
                      </div>
                      <!-- <img
                      :src="asset(`images/ui_elements/ic_user_online.png`)"
                      alt="channel_image"
                      class="w-10 mr-1 align-self-center"
                      >-->
                      <img
                        :src="asset(`images/channels/${room.created_by.channel.name}.png`)"
                        alt="channel_image"
                        class="w-10 align-self-center channel-image"
                      >
                    </span>
                  </template>
                </div>
              </div>
            </div>
          </div>
          <!-- End of Discussions -->
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import chatMixin from "@/mixins/ChatMixin";
import moment from "moment";
import EventBus from "@/EventBus.js";
import { VclBulletList } from "vue-content-loading";

export default {
  components: {
    VclBulletList
  },
  mixins: [chatMixin],
  computed: {
    sortedRoomList() {
      let sorted = _.sortBy(this.roomList, [
        function(o) {
          return o.updated_at;
        }
      ]).reverse();
      return sorted;
    },

    requestRoomList() {
      let list = [];
      for (const key in this.roomList) {
        if (!_.isNull(this.roomList[key].livechat)) {
          if (this.roomList[key].livechat.status == "request") {
            list.push(this.roomList[key]);
          }
        }
      }
      return list;
    },
    liveRoomList() {
      let list = [];
      for (const key in this.roomList) {
        if (!_.isNull(this.roomList[key].livechat)) {
          if (this.roomList[key].livechat.status == "live") {
            list.push(this.roomList[key]);
          }
        }
      }
      return list;
    }
  },
  data() {
    return {
      searchRoomList: "",
      roomList: null,
      loading: false
    };
  },
  watch: {
    searchRoomList() {
      let stateRoomList = this.$store.getters["chat/roomList"];
      if (this.searchRoomList.length > 0) {
        this.roomList = stateRoomList.filter(item => {
          let filtered =
            item.created_by.name.toLowerCase().includes(this.searchRoomList) ||
            item.channel.name.toLowerCase().includes(this.searchRoomList);
          return filtered;
        });
      } else {
        this.roomList = stateRoomList;
      }
    }
  },
  methods: {
    parseDate(date) {
      return moment(date, "YYYY-MM-DD kk:mm:ss").fromNow();
    },
    isSelected(roomId) {
      if (!this.selectedRoom) {
        return false;
      }
      return this.selectedRoom.id == roomId;
    },
    getLastMessage(content) {
      let lastMessage = _.last(content);
      let lastContent = _.last(lastMessage.content);
      switch (lastContent.type) {
        case "text":
          if (lastContent.text.length > 15) {
            return lastContent.text.substr(0, 15) + "..";
          }
          return lastContent.text;
          break;
        case "carousel":
          return "Carousel message";
          break;
        case "confirm":
          return "Confirm message";
          break;
        case "image":
          return "Image message";
          break;
        case "summary":
          return "Summary message";
          break;
        default:
          return "Others message";
          break;
      }
    },
    async selectChat(selectedRoom) {
      EventBus.$emit("closeChatSidebar");

      await this.$store.dispatch("chat/selectRoom", {
        room: selectedRoom,
        senderId: this.$store.getters.localStorage.decodedUserId
      });
    }
  },
  async mounted() {
    this.loading = true;
    await this.$store.dispatch("chat/getRoomList");
    this.roomList = this.$store.getters["chat/roomList"];
    this.loading = false;

    // if user clicked notif item
    if (!_.isUndefined(this.$route.params.fromNotif)) {
      this.$store.dispatch("chat/selectRoom", {
        room: this.$route.params.data.room
      });
    }
  }
};
</script>
<style lang="scss" scoped>
.chat-list {
  z-index: 1;
}
.sidebar {
  background: #ffffff;
  height: 100%;
  padding-top: 20px !important;
  .container {
    padding-left: 5px;
    padding-right: 0px;
  }
  .search {
    margin-bottom: 0;
    input {
      height: 5vh;
      font-size: 0.8rem;
    }
    margin-bottom: 5px;

    //   font-size: inherit
  }
  .sort {
    margin-bottom: 10px;
  }
}
.discussions {
  max-height: 70vh;
  overflow-y: scroll;
  &::-webkit-scrollbar {
    display: none;
  }
}
.sidebar .discussions .single {
  &:hover {
    background: #fdfdfd !important;
  }

  & {
    border-bottom: 0.2px solid #dee2e6 !important;
    position: relative;
    cursor: pointer;
  }
  &:first-child {
    border-top: 0.2px solid #dee2e6 !important;
  }
}

.avatar-md {
  box-shadow: none;
}

.channel-image {
  position: absolute;
  width: 25px !important;
  left: 10px;
  bottom: 10px;
}
.bg-active {
  background: #fdfdfd;
}
</style>